<?php 

    /* 
        Konfiguracja PaySafeCard
    */
        $config = array(
            'psc' => array(

                /* 
                    Zainicjuj w tym miejscu ID partnera
                    odbierającego płatność
                */
                'userid' => ,

                'amount' => 10,

                /* 
                    PIN, który należy skopiować z zakładki "Sklepy"
                    w panelu partnera www.rushpay.pl

                    Pamiętaj, aby nikomu go nie udostępniać. 
                    Możesz w ten sposób narazić się na ogromne straty finansowe!
                */
                'pin' => '',

                'shopid' => '',

                /*
                    Tytuł płatności
                */
                'description' => 'Przykładowy tytuł',
				
				/*
					Adres url pod który klient ma zostać przekierowany
					po pomyślnej płatności
				*/
				'return_ok' => 'https://paybylink.pl/psc/?status=ok',
				
				/*
					Adres url pod który klient ma zostać przekierowany
					po negatywnej płatności
				*/
				'return_fail' => 'https://paybylink.pl/psc/?status=fail',
				
				/*
					Adres url pod który system rushpay
					ma przesłać informacje do księgowości
				*/
				'url' => 'https://paybylink.pl/psc/?checkPayment',
            )
        );

    /*
        Inicjujemy klasę mPaySafeCard
    */
        include('mpsc.php');    
        $psc = new mPaySafeCard;


    /* 
        Odbiór i księgowanie płatności

        !!!!
        POLECAMY ZROBIĆ ODDZIELNY SKRYPT DO SPRAWDZANIA PŁATNOŚCI!
        !!!!
    */

     if(isset($_GET['checkPayment']) && $_POST['status']) {

        /* 
            Wyłączamy szablon
        */
            ob_clean();

        /*  
            Dostęp do tej zakładki może mieć tylko i wyłącznie rushpay!
            Nie należy usuwać oraz modyfikować tej funkcji.
        */
            $psc->validate_ipn();

        /* 
            Należy zabezpieczyć się przed nieautoryzowanymi płatnościami.
            Koniecznie sprawdzaj jaki userid otrzymał tą płatność!
        */
            $psc->validate_user($config, $_POST);

        /*
            rushpay prześle metodą post pod zdefiniowany link url w formularu
            pakiet pakietów. 
        
            status      => Status płatności TRUE i FALSE
            test        => transakcja testowa = true, produkcja = false
            userid      => id przyjmującego płatność
            pid         => Unikalny numer transakcji 
            mtid        => Unikalny numer transakcji w PSC
            control     => Pole dla sklepu, umożliwiające m.in zapisanie sesji
            amount      => Wartość zamówienia (kuponu PSC)
            description => Opis płatności zdefiniowany w fomrmularzu
            hash        => Indywidualna suma kontrolna w md5()
        */

        /* 
            Przykład zastosowania
        */
            if($_POST['status'] == TRUE) { 
                // dalsza część kodu 
                // np. zapytanie mysql
                // SELECT * FROM `payments` WHERE `control` = $_POST['control']
            }

        /* 
            Zamykamy skrypt odpowiedzią dla rushpay
        */
            exit('OK');
     } 

    /* 
        Generujemy formularz płatności
    */
        if(isset($_POST['send'])) { 

            if(isset($config['psc']['amount'])) { 
				if (!is_numeric($config['psc']['amount']) == TRUE OR $config['psc']['amount'] < 1) {
		            $error = 'Minimalna kwota transakcji to 1 PLN';
				}
	        } else {
	        	$errormsg = 'Minimalna kwota transakcji to 1 PLN';
	        }

	       
            if(!isset($errormsg)) { 

                /* 
                    Poniższe funkcje wygenerują formularz
                    oraz przeniosą do płatności
                */
                $psc->add('userid', $config['psc']['userid']);
                $psc->add('shopid', $config['psc']['shopid']);
                $psc->add('return_ok', $config['psc']['return_ok']);
                $psc->add('return_fail', $config['psc']['return_fail']);
                $psc->add('url', $config['psc']['url']);
                $psc->add('description', $config['psc']['description']);
                $psc->add('amount', $config['psc']['amount']);
                $psc->add('hash', hash('sha256', $config['psc']['userid'] . $config['psc']['pin'] . $config['psc']['amount']));
                $psc->add('control', '123');
                $psc->submit();

                /* 
                    Jeśłi wystąpił by błąd z generowaniem płatności
                    klient zobaczy poniższy komunikat
                */
                $errormsg = 'Płatność nie mogła zostać wygenerowana.';
            }
        }

    /* 
        Poniżej możesz skonfigurować odpowiedzi w przypadku
        negatywnych lub pozytywnych płatności
    */

         if(isset($_GET['status']) && $_GET['status'] == 'ok') 
            $okmsg = 'Congratulations, the payment was successful.';

         if(isset($_GET['status']) && $_GET['status'] == 'fail') 
            $errormsg = 'Unfortunately, the payment was negative.';
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="pl">
   <head>
      <meta http-equiv="content-type" content="text/html; charset=utf-8" />
      <title>This is an example script for PaySafeCard payments via paybylink.pl for mencharts.</title>
      <link href="https://rushpay.pl/api/demo/css.css" rel="stylesheet" type="text/css">
   </head>
   <body>
     <div id="page">
         <div class="center title">You buy a test product </div>
         <br/>
         <div class="center">
            <p>
                This is an example script for PaySafeCard payments via paybylink.pl for mencharts.
            </p>

            <?php if(isset($okmsg)) { ?><div class="msg ok"><?php echo $okmsg; ?></div><?php } ?>
            <?php if(isset($errormsg)) { ?><div class="msg error"><?php echo $errormsg; ?></div><?php } ?>
            
            <form method="post" >
               <input type="hidden" name="send" value="" />   
              Amount <strong><?php echo number_format($config['psc']['amount'],2); ?> PLN</strong><br/><br/>
               <button class="button" type="submit">Next step</button>
            </form>
    
         </div>
      </div>
   </body>
</html>
